import 'example_objects.dart';
import 'package:miodi/miodi.dart';
import 'dart:math';

class AppComponent extends MiodiComponent {
  final String dependency;

  AppComponent(this.dependency)
      : super([
          module([
            factory(IExampleFactory, () => ExampleFactory()),
            singleton(IExampleSingleton, () => ExampleSingleton()),
//      factory(DependencyModuleExample, () => DependencyModuleExample(dependency))
          ]),
          _module,
          CustomModule(dependency),
        ]);
}

final defaultComponent = component([
  module([
//    factory(IExampleFactory, () => ExampleFactory()),
//    singleton(IExampleSingleton, () => ExampleSingleton()),
  ]),
]);

final _module = module([
//  factory(IExampleFactory, () => ExampleFactory()),
//  singleton(IExampleSingleton, () => ExampleSingleton()),
]);

class CustomModule extends MiodiModule {
  final String dependency;

  CustomModule(this.dependency) : super([
    factory(
        DependencyModuleExample, () => DependencyModuleExample(dependency)),
        RandomProvider(CustomProvideExample, () => CustomProvideExample())
//    factory(IExampleFactory, () => ExampleFactory()),
//    singleton(IExampleSingleton, () => ExampleSingleton()),
  ]);
}

class RandomProvider extends Provider {
  RandomProvider(Type type, Creator creator) : super(type, creator);

  @override
  provide() {
    var provide = Random().nextBool();
    return provide ? creator() : null;
  }
}
